/*
 * radios-cross.c - host file for cross RadiOS ncc.
 */

#include <string.h>


#ifndef LCCDIR
#define LCCDIR "/usr/local/lib/lcc/"
#endif

char *suffixes[] = { ".c", ".i", ".asm", ".rdf", ".rdx", 0 };
char inputs[256] = "";
char *cpp[] = { LCCDIR "cpp",
	"-U__GNUC__", "-D_POSIX_SOURCE", "-D__STDC__=1", "-D__STRICT_ANSI__",
	"-Dradios", "-D__NASM__", "-D__signed__=signed",
	"$1", "$2", "$3", 0 };
char *include[] = {"-I" LCCDIR "../native/usr/include", 0 };
char *com[] = {LCCDIR "rcc", "-target=x86/nasm", "$1", "$2", "$3", 0 };
char *as[] = { LCCDIR "../bin/nasm", "-a", "-frdf", "-O99", "-o", "$3", "$1", "$2", 0 };
char *ld[] = {
	/*  0 */ LCCDIR "../bin/ldrdf",
	/*  1 */ "", "", "",
	/*  4 */ "", "", "$1",
	/*  7 */ "-s", "-o", "$3",
	/* 10 */ "-L", LCCDIR "../native/usr/lib/", 
	/* 12 */ LCCDIR "../native/usr/lib/rtinit.rdf",
	/* 13 */ "$2",
	/* 14 */ LCCDIR "../native/usr/lib/rtexit.rdf",
	/* 15 */ "", "", "",
	/* 18 */ "", "", "",
	0 };

extern char *concat(char *, char *);

int option(char *arg) {
  	if (strncmp(arg, "-lccdir=", 8) == 0) {
		cpp[0] = concat(&arg[8], "cpp");
		include[0] = concat("-I", concat(&arg[8], "/include"));
		include[1] = concat("-I", concat(&arg[8], "/gcc/include"));
		ld[9]  = concat(&arg[8], "/gcc/crtbegin.o");
		ld[12] = concat("-L", &arg[8]);
		ld[14] = concat("-L", concat(&arg[8], "/gcc"));
		ld[19] = concat(&arg[8], "/gcc/crtend.o");
		com[0] = concat(&arg[8], "/rcc");
	} else if (strcmp(arg, "-p") == 0 || strcmp(arg, "-pg") == 0) {
		ld[7] = "/usr/lib/gcrt1.o";
		ld[18] = "-lgmon";
	} else if (strcmp(arg, "-b") == 0) 
		;
	else if (strcmp(arg, "-g") == 0)
		;
	else if (strncmp(arg, "-ld=", 4) == 0)
		ld[0] = &arg[4];
	else if (strcmp(arg, "-static") == 0) {
	        ld[3] = "-static";
	        ld[4] = "";
	} else
		return 0;
	return 1;
}
