/* ndk - [ arch.c ]
 *
 * Defines the architecture dependant initialization
 *
 * (c)2004 dcipher / neuraldk
 *           www.neuraldk.org
 */

#include <arch.h>
#include <console.i386.h>
#include <timer.i386.h>
#include <task.i386.h>
#include <pager.h>
#include <idt.h>
#include <pic.h>
#include <rZero.h>

ErrorCode architectureInit(unsigned long magic, unsigned long addr)
{
   consoleInit();
   multibootInit(magic, addr);
   pagerInit();
   idtInit();
   /* setup the PIC */
   picInit();
   rZeroInit();
   timerInit();
   //vm86Init();
   //memoryInit();
   taskInit();

   return ErrorNoError;
}
