package org.neuraldk.ddfc;
import java.util.*;

class DriverItem
{
	Vector paramTypes, paramNames;
	String name;
	String type;
	String getFunction, setFunction;	// for parameters
	String handlerFunction;				// for functions
	Vector subItems = null;
	
	public DriverItem( String functionName, Vector parameterNames, Vector parameterTypes, String returnType)
	{
		name = functionName;
		paramTypes = parameterTypes;
		paramNames = parameterNames;
		type = returnType;
		
		System.out.println(this);
	}
	
	public DriverItem( String paramName, String paramType )
	{
		name = paramName;
		type = paramType;
	}
	
	public void setGetFunction(String getFunction)
	{
		this.getFunction = getFunction;
	}
	
	public void setSetFunction(String setFunction)
	{
		this.setFunction = setFunction;
	}
	
	public void setHandlerFunction( String function )
	{
		handlerFunction = function;
	}
	
	public boolean isParameter()
	{
		/* if the handler function is null, then it's a parameter.  Parameters 
		 * set both setFunction and getFunction
		 */
		return (handlerFunction == null) && (setFunction != null);
	}
	
	public boolean isFunction()
	{
		return (handlerFunction != null);
	}
	
	public boolean isNamespace()
	{
		return (handlerFunction == null) && (setFunction == null);
	}
	
	public String getName()
	{
		return name;
	}
	
	public String getType()
	{
		return type;
	}
	
	public int getNumParams()
	{
		int numParams = 0;
		
		if(paramTypes != null)
		{
			numParams = paramTypes.size();
		}
		
		return numParams;
	}
	
	public String getParamType(int paramNum)
	{
		return (String)paramTypes.get(paramNum);
	}
	
	public String getParamName(int paramNum)
	{
		return (String)paramNames.get(paramNum);
	}	
	
	public String getGetFunction()
	{
		return getFunction;
	}
	
	public String getSetFunction()
	{
		return setFunction;
	}
	
	public String getHandlerFunction()
	{
		return handlerFunction;
	}
	
	public Vector getSubItems()
	{
		if(subItems == null)
		{
			/* only create the vector when we actually need it */
			subItems = new Vector();
		}
		
		return subItems;
	}
	
	public String toString()
	{
		return name + " ( " + paramTypes + " ): " + type;
	}
}