/* ndk - [ serialInterface.c ] 
 * 
 * The interface for the serial driver
 * Automatically generated.  Do not edit!
 * 
 * (c) 2005 dcipher / neuraldk
 * 
 * For more information on ndk and device drivers, please visit
 * www.neuraldk.org
 */

const String author = "dcipher / neuraldk";
const String namespace = "driver.output";
const String description = "Serial port";
const String driver = "serial";

/* the following is used to avoid a bunch of malloc calls per each 
 * function call.  Instead, they're all allocated from this static 
 * pool.
 */
static DriverParam params[2];
static DriverParam *paramPointer

ErrorCode driverInit(Driver drv)
{
   ErrorCode err = ErrorNoError;

   err = serialDetect(drv)
   if(err == ErrorNoError)
   {
      if(!err) err = driverReserveIrq(3);
      if(!err) err = driverReserveIrq(4);
      if(!err) err = driverReservePortRange(1016, 1023);
      if(!err) err = driverReservePortRange(760, 767);
      if(!err) err = driverReservePortRange(1000, 1007);
      if(!err) err = driverReservePortRange(744, 751);


      paramPointer = &params[0];
      if(!err) err = driverParamCreate(&paramPointer[0], "n", DriverParamUnsignedInteger32);
      if(!err) err = driverItemCreateFunction(driverItem, "serial", DriverParamVoid, 1, paramPointer, driverSerialRoot);
      driverRoot = driverItem;
      {
         currentHub = driverItem;

         if(!err) err = driverParamCreate(&paramPointer[0], "n", DriverParamUnsignedInteger32);
         if(!err) err = driverItemCreateFunction(driverItem, "baud", DriverParamVoid, 1, paramPointer, driverSerialSetBaud);
         if(!err) err = driverItemAdd(currentHub, driverItem);

         if(!err) err = driverItemCreateFunction(driverItem, "baud", DriverParamUnsignedInteger32, 0, paramPointer, driverSerialGetBaud);
         if(!err) err = driverItemAdd(currentHub, driverItem);

         if(!err) err = driverParamCreate(&paramPointer[0], "n", DriverParamUnsignedInteger8);
         if(!err) err = driverItemCreateFunction(driverItem, "parity", DriverParamVoid, 1, paramPointer, driverSerialSetParity);
         if(!err) err = driverItemAdd(currentHub, driverItem);

         if(!err) err = driverItemCreateFunction(driverItem, "parity", DriverParamUnsignedInteger8, 0, paramPointer, driverSerialGetParity);
         if(!err) err = driverItemAdd(currentHub, driverItem);

         if(!err) err = driverItemCreateParameter(driverItem, "testing", DriverParamUnsignedInteger32, driverGetTesting, driverSetTesting);
         if(!err) err = driverItemAdd(currentHub, driverItem);
         {
            currentHub = driverItem;

            if(!err) err = driverItemCreateParameter(driverItem, "testInt", DriverParamUnsignedInteger32, driverGetTesting, driverSetTesting);
            if(!err) err = driverItemAdd(currentHub, driverItem);

         }
         if(!err) err = driverItemCreateParameter(driverItem, "baud", DriverParamUnsignedInteger32, driverSerialGetBaud, driverSerialSetBaud);
         if(!err) err = driverItemAdd(currentHub, driverItem);

         if(!err) err = driverItemCreateParameter(driverItem, "dataBits", DriverParamUnsignedInteger8, driverSerialGetDataBits, driverSerialSetDataBits);
         if(!err) err = driverItemAdd(currentHub, driverItem);

         if(!err) err = driverItemCreateParameter(driverItem, "stopBits", DriverParamUnsignedInteger8, driverSerialGetStopBits, driverSerialSetStopBits);
         if(!err) err = driverItemAdd(currentHub, driverItem);

         if(!err) err = driverItemCreateParameter(driverItem, "parity", DriverParamUnsignedInteger8, driverSerialGetParity, driverSerialSetParity);
         if(!err) err = driverItemAdd(currentHub, driverItem);

         if(!err) err = driverParamCreate(&paramPointer[0], "n", DriverParamUnsignedInteger32);
         if(!err) err = driverItemCreateFunction(driverItem, "read", DriverParamPointer, 1, paramPointer, driverSerialSerialRead);
         if(!err) err = driverItemAdd(currentHub, driverItem);

         if(!err) err = driverParamCreate(&paramPointer[0], "n", DriverParamUnsignedInteger32);
         if(!err) err = driverParamCreate(&paramPointer[1], "buf", DriverParamPointer);
         if(!err) err = driverItemCreateFunction(driverItem, "write", DriverParamVoid, 2, paramPointer, driverSerialSerialWrite);
         if(!err) err = driverItemAdd(currentHub, driverItem);

         if(!err) err = driverItemCreateFunction(driverItem, "get", DriverParamUnsignedInteger8, 0, paramPointer, driverSerialGet);
         if(!err) err = driverItemAdd(currentHub, driverItem);

         if(!err) err = driverParamCreate(&paramPointer[0], "c", DriverParamUnsignedInteger8);
         if(!err) err = driverItemCreateFunction(driverItem, "put", DriverParamVoid, 1, paramPointer, driverSerialPut);
         if(!err) err = driverItemAdd(currentHub, driverItem);

      }
   }
   return err
}

ErrorCode driverFinal(Driver drv);
{
   ErrorCode err = ErrorNoError;

   err = serialFinal(drv)

   return err
}
